import processing.serial.*;

Serial myPort;

import controlP5.*;

import peasy.*;
import processing.opengl.*;

PeasyCam cam;

PMatrix3D currCameraMatrix;

PGraphics3D g3;

int SliderVal;

ControlP5 MyController;

Slider mySlider;

void setup(){
  size(1300,800, OPENGL);
  g3 = (PGraphics3D)g;
  MyController = new ControlP5(this);
  
  cam = new PeasyCam(this, 200, 300, 100, 500);
  
  mySlider = MyController.addSlider("Motor Controller", 0, 230, 0, 20, 200, 360, 30);
  mySlider.setColorBackground(color(44, 41, 207));
  mySlider.setColorForeground(color(88, 173, 152));
  mySlider.setColorActive(color(44,140,209));
  mySlider.setColorLabel(color(0, 0, 0));
  
  MyController.setAutoDraw(false);
  myPort = new Serial(this, "/dev/cu.usbmodem2101", 9600);
}

 void gui(){
  currCameraMatrix = new PMatrix3D(g3.camera);
  camera();
  MyController.draw();
  g3.camera = currCameraMatrix;
} 

void draw(){
  
  background(163, 104, 163);
  noFill();
  stroke(20);
  pushMatrix();
  translate(250, 300, 20);
  sphere(200);
  popMatrix();
  gui();
  
  SliderVal = (int) mySlider.getValue();
  
  println(SliderVal);
  
  myPort.write(SliderVal);
}
