import processing.serial.*;

Serial myPort; // Name of port

int sliderPosition; // Variable to store the current position of the slider
boolean isDraggingSlider = false;

void setup() {
  size(750, 375);
  myPort = new Serial(this, "/dev/cu.usbmodem101", 9600);
}

void drawSlider() {
  float sliderX = map(sliderPosition, 0, width, 20, width - 20); // Calculate the x-coordinate of the slider based on its position

  // Draw the track
  stroke(0);
  line(20, height / 2, width - 20, height / 2);

  // Draw the slider button
  fill(255);
  rectMode(CENTER);
  rect(sliderX, height / 2, 10, 20);
}

void mousePressed() {
  // Check if the mouse is within the bounds of the slider button
  float sliderX = map(sliderPosition, 0, width, 20, width - 20);
  float sliderY = height / 2;
  float buttonWidth = 10;
  float buttonHeight = 20;

  if (mouseX >= sliderX - buttonWidth / 2 && mouseX <= sliderX + buttonWidth / 2 &&
      mouseY >= sliderY - buttonHeight / 2 && mouseY <= sliderY + buttonHeight / 2) {
    // Set a flag to indicate that the slider is being dragged
    isDraggingSlider = true;
  }
}

void mouseReleased() {
  // Reset the dragging flag when the mouse is released
  isDraggingSlider = false;
}

void mouseDragged() {
  if (isDraggingSlider) {
    // Update the slider position based on the mouse's x-coordinate
    sliderPosition = constrain(mouseX, 0, width);
    myPort.write(sliderPosition);
   
    
  }
}

void displayValue() {
  fill(0);
  textAlign(CENTER, CENTER);
  text(sliderPosition, width / 2, height / 2 + 30);
  
}


void draw() {
  background(220);
  // Draw the slider
  drawSlider();
  // Display the value
  displayValue();
  
}
